#!/usr/bin/env python

import urllib2
from xml.etree.ElementTree import parse
import time
from MythTV import MSearch
from urlparse import urlparse
import os
import ConfigParser
from httplib import HTTP

class MythTVService:

    CONFFILE = os.path.expanduser("~")+"/.mythtv-scope-location.conf"

    def findBE(self, NEW=False):
        print "Finding Backend"
        BACKENDLOCATION = None
        for l in MSearch().searchMythBE():
          if l['st'] == 'urn:schemas-mythtv-org:device:MasterMediaServer:1':
            BACKEND = l['location']
            BACKEND = urlparse(BACKEND)
            BACKENDLOCATION = BACKEND.scheme+"://"+BACKEND.netloc
            config = ConfigParser.RawConfigParser()
            if NEW:
                config.add_section('Backend')
            config.set('Backend', 'Location', BACKENDLOCATION)
            with open(self.CONFFILE, 'wb') as configfile:
                config.write(configfile)
        return BACKENDLOCATION

    def checkURL(self, url):
        try:
            p = urlparse(url)
            h = HTTP(p[1])
            h.putrequest('HEAD', p[2])
            h.endheaders()
            if h.getreply()[0] == 200:
                return 1
            else:
                return 0
        except IOError:
            return 0

    def update_all(self):
        if not os.path.isfile(self.CONFFILE):
            self.findBE(True)
        config = ConfigParser.RawConfigParser()
        config.read(self.CONFFILE)
        BACKENDLOCATION = config.get('Backend', 'Location')
        if not self.checkURL(BACKENDLOCATION):
            BACKENDLOCATION = self.findBE(True)
            if BACKENDLOCATION == None:
                exit(404)
        base = BACKENDLOCATION+"/Dvr/GetRecordedList"
        response = urllib2.urlopen(base)
        tree = parse(response)
        elem = tree.getroot()
        results = elem.find("Programs")
        self.lastupdated = time.time()
        RESULTSLIST=[]
        for l in results:
            PROGRAMDATA={}
            PROGRAMDATA['StartTime'] = l.findtext('StartTime')
            PROGRAMDATA['EndTime'] = l.findtext('EndTime')
            PROGRAMDATA['Title'] = l.findtext('Title')
            PROGRAMDATA['SubTitle'] = l.findtext('SubTitle')
            PROGRAMDATA['Category'] = l.findtext('Category')
            PROGRAMDATA['CatType'] = l.findtext('CatType')
            PROGRAMDATA['Repeat'] = l.findtext('Repeat')
            PROGRAMDATA['VideoProps'] = l.findtext('VideoProps')
            PROGRAMDATA['AudioProps'] = l.findtext('AudioProps')
            PROGRAMDATA['SubProps'] = l.findtext('SubProps')
            PROGRAMDATA['SeriesId'] = l.findtext('SeriesId')
            PROGRAMDATA['ProgramId'] = l.findtext('ProgramId')
            PROGRAMDATA['Stars'] = l.findtext('Stars')
            PROGRAMDATA['FileSize'] = l.findtext('FileSize')
            PROGRAMDATA['LastModified'] = l.findtext('LastModified')
            PROGRAMDATA['ProgramFlags'] = l.findtext('ProgramFlags')
            PROGRAMDATA['FileName'] = l.findtext('FileName')
            PROGRAMDATA['HostName'] = l.findtext('HostName')
            PROGRAMDATA['Airdate'] = l.findtext('Airdate')
            PROGRAMDATA['Description'] = l.findtext('Description')
            PROGRAMDATA['Inetref'] = l.findtext('Inetref')
            PROGRAMDATA['Season'] = l.findtext('Season')
            PROGRAMDATA['Episode'] = l.findtext('Episode')
            PROGRAMDATA['ChanId'] = l.find('Channel').findtext('ChanId')
            PROGRAMDATA['ChanNum'] = l.find('Channel').findtext('ChanNum')
            PROGRAMDATA['CallSign'] = l.find('Channel').findtext('CallSign')
            PROGRAMDATA['IconURL'] = l.find('Channel').findtext('IconURL')
            PROGRAMDATA['ChannelName'] = l.find('Channel').findtext('ChannelName')
            PROGRAMDATA['MplexId'] = l.find('Channel').findtext('MplexId')
            PROGRAMDATA['TransportId'] = l.find('Channel').findtext('TransportId')
            PROGRAMDATA['ServiceId'] = l.find('Channel').findtext('ServiceId')
            PROGRAMDATA['NetworkId'] = l.find('Channel').findtext('NetworkId')
            PROGRAMDATA['ATSCMajorChan'] = l.find('Channel').findtext('ATSCMajorChan')
            PROGRAMDATA['ATSCMinorChan'] = l.find('Channel').findtext('ATSCMinorChan')
            PROGRAMDATA['Format'] = l.find('Channel').findtext('Format')
            PROGRAMDATA['Modulation'] = l.find('Channel').findtext('Modulation')
            PROGRAMDATA['Frequency'] = l.find('Channel').findtext('Frequency')
            PROGRAMDATA['FrequencyId'] = l.find('Channel').findtext('FrequencyId')
            PROGRAMDATA['FrequencyTable'] = l.find('Channel').findtext('FrequencyTable')
            PROGRAMDATA['FineTune'] = l.find('Channel').findtext('FineTune')
            PROGRAMDATA['SIStandard'] = l.find('Channel').findtext('SIStandard')
            PROGRAMDATA['ChanFilters'] = l.find('Channel').findtext('ChanFilters')
            PROGRAMDATA['SourceId'] = l.find('Channel').findtext('SourceId')
            PROGRAMDATA['InputId'] = l.find('Channel').findtext('InputId')
            PROGRAMDATA['CommFree'] = l.find('Channel').findtext('CommFree')
            PROGRAMDATA['UseEIT'] = l.find('Channel').findtext('UseEIT')
            PROGRAMDATA['Visible'] = l.find('Channel').findtext('Visible')
            PROGRAMDATA['XMLTVID'] = l.find('Channel').findtext('XMLTVID')
            PROGRAMDATA['DefaultAuth'] = l.find('Channel').findtext('DefaultAuth')
            PROGRAMDATA['Programs'] = l.find('Channel').findtext('Programs')
            PROGRAMDATA['Status'] = l.find('Recording').findtext('Status')
            PROGRAMDATA['Priority'] = l.find('Recording').findtext('Priority')
            PROGRAMDATA['StartTs'] = l.find('Recording').findtext('StartTs')
            PROGRAMDATA['EndTs'] = l.find('Recording').findtext('EndTs')
            PROGRAMDATA['RecordId'] = l.find('Recording').findtext('RecordId')
            PROGRAMDATA['RecGroup'] = l.find('Recording').findtext('RecGroup')
            PROGRAMDATA['PlayGroup'] = l.find('Recording').findtext('PlayGroup')
            PROGRAMDATA['StorageGroup'] = l.find('Recording').findtext('StorageGroup')
            PROGRAMDATA['RecType'] = l.find('Recording').findtext('RecType')
            PROGRAMDATA['DupInType'] = l.find('Recording').findtext('DupInType')
            PROGRAMDATA['DupMethod'] = l.find('Recording').findtext('DupMethod')
            PROGRAMDATA['EncoderId'] = l.find('Recording').findtext('EncoderId')
            PROGRAMDATA['Profile'] = l.find('Recording').findtext('Profile')
            PROGRAMDATA['ContentType'] = 'TELEVISION'
            PROGRAMDATA['Tagline'] = ''
            PROGRAMDATA['Director'] = ''
            PROGRAMDATA['Studio'] = ''
            PROGRAMDATA['BackendLocation'] = BACKENDLOCATION
            artwork = l.find("Artwork")
            artworkinfos = artwork.find("ArtworkInfos")
            for art in artworkinfos:
                PROGRAMDATA[art.findtext('StorageGroup')] = art.findtext('URL')
            RESULTSLIST.append(PROGRAMDATA)
        base = BACKENDLOCATION+"/Video/GetVideoList"
        response = urllib2.urlopen(base)
        tree = parse(response)
        elem = tree.getroot()
        results = elem.find("VideoMetadataInfos")
        for l in results:
            VIDEODATA={}
            VIDEODATA['Id'] = l.findtext('Id')
            VIDEODATA['Title'] = l.findtext('Title')
            VIDEODATA['SubTitle'] = l.findtext('SubTitle')
            VIDEODATA['Tagline'] = l.findtext('Tagline')
            VIDEODATA['Director'] = l.findtext('Director')
            VIDEODATA['Studio'] = l.findtext('Studio')
            VIDEODATA['Description'] = l.findtext('Description')
            VIDEODATA['Certification'] = l.findtext('Certification')
            VIDEODATA['Inetref'] = l.findtext('Inetref')
            VIDEODATA['Collectionref'] = l.findtext('Collectionref')
            VIDEODATA['HomePage'] = l.findtext('HomePage')
            VIDEODATA['ReleaseDate'] = l.findtext('ReleaseDate')
            VIDEODATA['AddDate'] = l.findtext('AddDate')
            VIDEODATA['UserRating'] = l.findtext('UserRating')
            VIDEODATA['Length'] = l.findtext('Length')
            VIDEODATA['PlayCount'] = l.findtext('PlayCount')
            VIDEODATA['Season'] = l.findtext('Season')
            VIDEODATA['Episode'] = l.findtext('Episode')
            VIDEODATA['ParentalLevel'] = l.findtext('ParentalLevel')
            VIDEODATA['Visible'] = l.findtext('Visible')
            VIDEODATA['Watched'] = l.findtext('Watched')
            VIDEODATA['Processed'] = l.findtext('Processed')
            VIDEODATA['ContentType'] = l.findtext('ContentType')
            VIDEODATA['FileName'] = l.findtext('FileName')
            VIDEODATA['Hash'] = l.findtext('Hash')
            VIDEODATA['Hostname'] = l.findtext('Hostname')
            VIDEODATA['Trailer'] = l.findtext('Trailer')
            artwork = l.find("Artwork")
            artworkinfos = artwork.find("ArtworkInfos")
            for art in artworkinfos:
                VIDEODATA[art.findtext('StorageGroup')] = art.findtext('URL')
            RESULTSLIST.append(VIDEODATA)
        return RESULTSLIST
        			
    def search(self, SEARCHTERM=None):
        FILTEREDLIST=[]
        try:
            if time.time() - self.lastupdated > 60:
                self.resultlist = self.update_all()
        except:
            self.resultlist = self.update_all()
        for result in self.resultlist:
            try:
                ST = SEARCHTERM.lower() 
            except:
                ST = ''
            if ST in result['Title'].lower() or ST in result['SubTitle'].lower() or ST in result['Tagline'].lower() or ST in result['Description'].lower() or ST in result['Director'].lower() or ST in result['Studio'].lower():
                FILTEREDLIST.append(result)
        return FILTEREDLIST

if __name__ == '__main__':
    mt = MythTVService()
    results = mt.search('house')
    for l in results:
        print l['Title'], l['SubTitle']
    exit(0)
    '''Action, Adult, Animals, Art_Music, Business, Children, Comedy, Crime/Mystery, Documentary, Drama, Educational, Food, Game, Health/Medical, History, Horror, HowTo, Misc, Movie, News, Reality, Romance, Science/Nature, SciFi/Fantasy, Shopping, Soaps, Spiritual, Sports, Talk, Travel, Unknown, War, Western'''
